#include "simulator.c"

FILE *g; /* File pointer for the file that contains the data to be fitted */
int readTableComparison[NUM_NUMERIC_INPUTS+NUM_OUTPUTS+NUM_INTRINSIC][3];
float comparison_var[NUM_NUMERIC_INPUTS+NUM_OUTPUTS+NUM_INTRINSIC];
float old_comparison_var[NUM_NUMERIC_INPUTS+NUM_OUTPUTS+NUM_INTRINSIC];

int sizeComparisonTable=0;

void initializeExpectedDataReadModule() {
  char fieldName[50],c;
  int i,indexReadTableComparison,indexField;

  indexReadTableComparison=0; indexField=0;
	c = ' ';
  while(indexReadTableComparison<NUM_NUMERIC_INPUTS+NUM_OUTPUTS && c!=';' && c!='\n') {
    i=0;
    while(((c=fgetc(g))==' ') && !feof(g));
    ungetc(c,g);
		while((c=fgetc(g))!=' ' && c !='\r' && c !='\n' && c!=';' && !feof(g)) fieldName[i++]=c;
    fieldName[i]='\0';
    if ( c=='\n' ) ungetc(c,g); 

    /* Now look up the fieldName to see the type of var. */
    for(i=0;i<NUM_NUMERIC_INPUTS+NUM_OUTPUTS;i++) {
      if (strcmp(numeric_field_names[i],fieldName)==0) {
				readTableComparison[indexReadTableComparison][0]=1;  /* NUMERIC */
				readTableComparison[indexReadTableComparison][1]=indexField;  /* POSITION in the file */
				readTableComparison[indexReadTableComparison][2]=i;  /* POSITION in numericVars*/
				indexReadTableComparison++;

				printf("%s in comparison_var[%d]\n",fieldName,i);  
      }
    }
    indexField++;
  }
  if (c!='\n') {
    while((c=fgetc(g))!='\n' && !feof(g)); /* Ignore the rest of the line */
    ungetc('\n',g);
  }

/*  	if (indexReadTableComparison < NUM_NUMERIC_INPUTS+NUM_OUTPUTS) { */
/*  		printf("\nWrong number of variables in observed data file. Only found %d of %d variables\n",indexReadTableComparison, NUM_NUMERIC_INPUTS+NUM_OUTPUTS); */
/*  		exit(-1); */
/*  	} */
	sizeComparisonTable = indexReadTableComparison;

}



void loadComparisonData() {
  int indexReadTableComparison,indexField,i;
  char c;

	for(i=0;i<NUM_NUMERIC_INPUTS;i++) {
	  //printf("comparison_var[%d] = %d\n",i,comparison_var[i]); 
		old_comparison_var[i] = comparison_var[i];
	}

  indexReadTableComparison=0; indexField=0;
	//  while(indexReadTableComparison<NUM_NUMERIC_INPUTS+NUM_OUTPUTS) {
  while(indexReadTableComparison<sizeComparisonTable) {
/*  		printf("readTableComp[%d][1]=%d\n",indexReadTableComparison,readTableComparison[indexReadTableComparison][1]); */
    if (readTableComparison[indexReadTableComparison][1]==indexField) {
      if (readTableComparison[indexReadTableComparison][0]==1) { 
				/*numeric */
				fgetc(g);
				if (!feof(g)) {
					fscanf(g,"%f",&(comparison_var[readTableComparison[indexReadTableComparison][2]]) );
				}
				else 
					break;
      }
      indexReadTableComparison++;
    }
    else {
      while((c=fgetc(g))!=' ' && c!=';' && !feof(g));
      ungetc(c,g);
    }
    indexField++;
  }
  
  if (c!=';') while((c=fgetc(g))!=';' && !feof(g));

/*  	for(i=0;i<NUM_NUMERIC_INPUTS;i++)  */
/*  		printf("comparison_var[%d]=%f\n",i,comparison_var[i]); */
}

void printResultHeaderComparison(FILE* outStream) {
  int i;
#ifdef INSTANTANEOUS
  fprintf(outStream,"%s",numeric_field_names[0]);
  for(i=1;i<NUM_NUMERIC_INPUTS+NUM_OUTPUTS+NUM_INTRINSIC+NUM_AGGREGATE;i++)
		fprintf(outStream," %s",numeric_field_names[i]);
  for(i=0;i<NUM_PROCS;i++)
		fprintf(outStream," %s",proc_names[i]);
  fprintf(outStream,";\n");
#else
  fprintf(outStream,"t");
  for(i=0;i<NUM_NUMERIC_INPUTS+NUM_OUTPUTS+NUM_INTRINSIC+NUM_AGGREGATE;i++) 
		fprintf(outStream," %s",numeric_field_names[i]);
  for(i=0;i<NUM_PROCS;i++)
		fprintf(outStream," %s",proc_names[i]);
  fprintf(outStream,";\n");
#endif	
}

void printOutputComparison(FILE* outStream) {
  int i;
#ifdef INSTANTANEOUS
  fprintf(outStream,"%f",result[0]);
  for(i=1;i<NUM_NUMERIC_INPUTS+NUM_OUTPUTS+NUM_INTRINSIC+NUM_AGGREGATE;i++)
		fprintf(outStream," %f",result[i]);
  for(i=0;i<NUM_PROCS;i++)
		fprintf(outStream," %d",evaluated_proc[i]);
  fprintf(outStream,";\n");
#else
  fprintf(outStream,"%f",t);
  for(i=0;i<NUM_NUMERIC_INPUTS+NUM_OUTPUTS+NUM_INTRINSIC+NUM_AGGREGATE;i++) 
		fprintf(outStream," %f",result[i]);
  for(i=0;i<NUM_PROCS;i++)
		fprintf(outStream," %d",evaluated_proc[i]);
  fprintf(outStream,";\n");
#endif
}



int main(int argc, char *argv[]) {
	int i;
  FILE *outStreamCompare, *outStreamSimulation;

  if (argc!=3) EXIT("Wrong number of arguments\n");
  if ((f=fopen(argv[1],"rt"))==NULL) EXIT("File open failed for (observable data)\n");
  if ((g=fopen(argv[2],"rt"))==NULL) EXIT("File open failed for (observed data)\n");

	printf("initialize Model\n");
  initializeModel();
	printf("initialize Observable data read module\n");
	initializeObservableDataReadModule();
	printf("initialize expected data read module\n");
  initializeExpectedDataReadModule();

  outStreamCompare = fopen("compare.out","wt");
	outStreamSimulation = fopen("simulation.out","wt");
  printResultHeaderComparison(outStreamCompare);
  printResultHeader(outStreamSimulation);


	/* Initialization of the simulation */
  t=0;
  loadObservableData(FIRST);    
	for(i=0;i<NUM_NUMERIC_INPUTS+NUM_OUTPUTS;i++) 
		old_var[i]=var[i];


	/* Main loop for the simulation */
#ifdef INSTANTANEOUS
  while(!feof(f)) 
#else
		while(t < NUM_TIMESTEPS) 
#endif
			{
				/* Do the simulation for the current input vector */
				simulate_one_timestep();
				
				loadComparisonData();    

				/* Store the values of this timestep as the old values */
				for(i=0;i<NUM_NUMERIC_INPUTS+NUM_OUTPUTS;i++) 
					old_var[i]=var[i];

				for(i=0;i<NUM_NUMERIC_INPUTS+NUM_OUTPUTS+NUM_INTRINSIC+NUM_AGGREGATE;i++)
					result[i]=var[i];
				printOutput(outStreamSimulation);


				/* Store the comparison value for each variable. */
				for(i=0;i<NUM_NUMERIC_INPUTS+NUM_OUTPUTS;i++)
					var[i]=comparison_var[i];

				/* Calculate the aggregates and intrinsics from the comparison values */
				for(i=0;i<NUM_AGGREGATE;i++) aggregate[i]();
	
				for(i=0;i<NUM_NUMERIC_INPUTS+NUM_OUTPUTS;i++) {
					var[i]=result[i];
					result[i]=comparison_var[i];
				}

				for(i=NUM_NUMERIC_INPUTS+NUM_OUTPUTS;i<NUM_NUMERIC_INPUTS+NUM_OUTPUTS+NUM_INTRINSIC+NUM_AGGREGATE;i++) 
					result[i]=var[i];

				/* Output the results  */
				printOutputComparison(outStreamCompare);


				/* Go to the next timestep */
				t++;

				loadObservableData(AFTER_FIRST);    
			}
	
  return 0;
}

