/* data.h */
#include <stdio.h>

#ifndef _DATA_H
#define _DATA_H

void print_data_tables();
void ensure_allocation(void*, char*);
void read_observation_vector(FILE*, double*);
void read_field_name(FILE*, char*);
void build_data_table(char*, char[][]);
double get_most_recent_observation(int, double);
double get_current_observation(int, double, double);

/* the number of fields in the file */
extern int nFields;

/* the table of values */
extern double **observed_values;

/* the number of total time points where observations are recorded */
extern int nObservationPoints;

/* Maps the position of the variable in the data table to the
   position of the variable in the complete variable list */
extern int *file_to_var_map;

/* Maps the position of the variable in the complete variable
   list back to its position in the file */
extern int var_to_file_map[];

#endif
